# -*- coding: utf-8 -*-
from setuphelpers import *

installdir       = makepath(programfiles32, 'Thonny')
my_configfile    = "configuration.ini"
configdir        = makepath(user_appdata, 'Thonny')
my_sitepackages  = 'site-packages'
sitepackagesdir  = makepath(programfiles32, 'Thonny', 'Lib', 'site-packages')

uninstallkey = ['Thonny_is1']


def install():
    # realize the standard install
    install_exe_if_needed("thonny-3.3.11.exe",
                          '/VERYSILENT /NORESTART /RESTARTEXITCODE=3010 /SP- /SUPPRESSMSGBOXES /CLOSEAPPLICATIONS /FORCECLOSEAPPLICATIONS /ALLUSERS',
                          key='Thonny_is1',
                          min_version='3.3.11')
    # then copy the configuration file to the install directory
    filecopyto(my_configfile, installdir)
    # we copy 3rd party packages into the install dir
    copytree2(my_sitepackages, sitepackagesdir)
    # finally, let's make a shortcut for the app on the desktop
    create_desktop_shortcut(r'Thonny',target=r'C:\Program Files (x86)\Thonny\thonny.exe',wDir=r'C:\Program Files (x86)\Thonny')


def uninstall():
    # removes the desktop shortcut
    remove_desktop_shortcut('Thonny')


def session_setup():
    print('Session setup for %s' % control.asrequirement())
    # let's start by creating the config directory if it doesn't exists
    mkdirs(configdir)
    # then we just past here our standard configuration file to the C:\Users\%username%\AppData\Roaming dir
    if not isfile(makepath(configdir, my_configfile)):
        filecopyto(makepath(installdir, my_configfile), configdir)


def update_package():
    pass
    # put here what to do to update package content with newer installers.
    # launched with command wapt-get update-package-sources <path-to-wapt-directory>
    # implicit context variables are WAPT, basedir, control, user, params, run
    # if attributes in control are changed, they should be explicitly saved to package file with control.save_control_to_wapt()


def audit():
    pass
    # put here code to check periodically that state is matching expectations
    # return "OK", "WARNING" or "ERROR" to report status in console.
    # all print statement are reported too
    return "OK"